Index: trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/ISequenceGenerator.java
===================================================================
--- trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/ISequenceGenerator.java	(revision 1330)
+++ 	(revision )
@@ -1,16 +1,0 @@
-package de.ugoe.cs.autoquest.plugin.alignment.seqgen;
-
-import java.util.Collection;
-import java.util.List;
-
-import de.ugoe.cs.autoquest.eventcore.Event;
-
-public interface ISequenceGenerator {
-	
-	public void generate(Collection<List<Event>> eventList);
-	public int[] get(int index);
-	
-	
-	
-	
-}
Index: trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/NumberSequence.java
===================================================================
--- trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/NumberSequence.java	(revision 1449)
+++ trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/NumberSequence.java	(revision 1449)
@@ -0,0 +1,34 @@
+package de.ugoe.cs.autoquest.plugin.alignment.seqgen;
+
+import java.util.ArrayList;
+
+public class NumberSequence {
+	private int[] sequence;
+	private int signature;
+	
+	public NumberSequence(int size) {
+		
+		sequence = new int[size];
+	}
+	
+	public String toString() {
+		return sequence.toString();
+		
+	}
+	
+	
+	
+	public int[] getSequence() {
+		return sequence;
+	}
+	public void setSequence(int[] sequence) {
+		this.sequence = sequence;
+	}
+	public int getSignature() {
+		return signature;
+	}
+	public void setSignature(int signature) {
+		this.signature = signature;
+	}
+
+}
Index: trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/RandomSequenceGenerator.java
===================================================================
--- trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/RandomSequenceGenerator.java	(revision 1330)
+++ trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/RandomSequenceGenerator.java	(revision 1449)
@@ -5,5 +5,5 @@
 import java.util.List;
 
-public class RandomSequenceGenerator implements ISequenceGenerator{
+public class RandomSequenceGenerator implements SequenceGenerator{
 
 	private int min;
@@ -33,5 +33,5 @@
 
 	@Override
-	public int[] get(int index) {
+	public NumberSequence get(int index) {
 		// TODO Auto-generated method stub
 		return null;
Index: trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SequenceGenerator.java
===================================================================
--- trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SequenceGenerator.java	(revision 1449)
+++ trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SequenceGenerator.java	(revision 1449)
@@ -0,0 +1,16 @@
+package de.ugoe.cs.autoquest.plugin.alignment.seqgen;
+
+import java.util.Collection;
+import java.util.List;
+
+import de.ugoe.cs.autoquest.eventcore.Event;
+
+public interface SequenceGenerator {
+	
+	public void generate(Collection<List<Event>> eventList);
+	public NumberSequence get(int index);
+	
+	
+	
+	
+}
Index: trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SimpleSequenceGenerator.java
===================================================================
--- trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SimpleSequenceGenerator.java	(revision 1330)
+++ trunk/autoquest-plugin-alignment/src/main/java/de/ugoe/cs/autoquest/plugin/alignment/seqgen/SimpleSequenceGenerator.java	(revision 1449)
@@ -17,16 +17,23 @@
 import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskBuilder;
 import de.ugoe.cs.autoquest.usageprofiles.SymbolMap;
+import de.ugoe.cs.util.console.Console;
 
 
-public class SimpleSequenceGenerator implements ISequenceGenerator {
+public class SimpleSequenceGenerator implements SequenceGenerator {
 
-	private ArrayList<int[]> numberseqs;
+	private ArrayList<NumberSequence> numberseqs;
 
 
 	public SimpleSequenceGenerator() {
-		this.numberseqs = new ArrayList<int[]>();
+		this.numberseqs = new ArrayList<NumberSequence>();
 	
 	}
 	
+	public void print() {
+		for (NumberSequence sequence : numberseqs) {
+				System.out.println(sequence.toString());
+		}
+		
+	}
 	
 	public void generate(Collection<List<Event>> sequences) {
@@ -35,6 +42,7 @@
 		if (sequences != null) {
 			TaskTreeManager ttm = new TaskTreeManager();
+			Console.println("Creating the task model");
 			ttm.createTaskModel(sequences);
-			
+			Console.println("Finished creating the task model");
 			TaskHandlingStrategy preparationTaskHandlingStrategy  = new TaskHandlingStrategy(TaskEquality.SEMANTICALLY_EQUAL);
 			SymbolMap<ITaskInstance, ITask> uniqueTasks = preparationTaskHandlingStrategy
@@ -49,5 +57,5 @@
 			for (IUserSession session : sessions) {
 				//Creating a new sequence that just consists of integers
-				int[] templist = new int[session.size()];
+				NumberSequence templist = new NumberSequence(session.size()) ;
 				for (int i = 0; i < session.size(); i++) {
 					ITaskInstance taskInstance = session.get(i); 
@@ -57,9 +65,9 @@
 						uniqueTasks.addSymbol(taskInstance,
 								taskInstance.getTask());
-								templist[i]=taskInstance.getTask().getId();
+								templist.getSequence()[i]=taskInstance.getTask().getId();
 								
 					} else {
 						taskBuilder.setTask(taskInstance, task);
-						templist[i]=task.getId();
+						templist.getSequence()[i]=task.getId();
 						
 					}
@@ -77,5 +85,5 @@
 
 	@Override
-	public int[] get(int index) {
+	public NumberSequence get(int index) {
 		return numberseqs.get(index);
 	}