Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/DifferenceSubstitutionMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/DifferenceSubstitutionMatrix.java	(revision 1571)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/DifferenceSubstitutionMatrix.java	(revision 1572)
@@ -2,5 +2,5 @@
  * 
  */
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
 
 import java.util.Collection;
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/NearbySubstitutionMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/NearbySubstitutionMatrix.java	(revision 1571)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/NearbySubstitutionMatrix.java	(revision 1572)
@@ -2,5 +2,5 @@
  * 
  */
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
 
 import java.util.Collection;
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/ObjectDistanceSubstitionMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/ObjectDistanceSubstitionMatrix.java	(revision 1571)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/ObjectDistanceSubstitionMatrix.java	(revision 1572)
@@ -1,3 +1,3 @@
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
 
 
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/SubstitutionMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/SubstitutionMatrix.java	(revision 1571)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/SubstitutionMatrix.java	(revision 1572)
@@ -1,3 +1,3 @@
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
 
 
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/TriangleMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/TriangleMatrix.java	(revision 1571)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/TriangleMatrix.java	(revision 1572)
@@ -1,8 +1,8 @@
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
 
 public class TriangleMatrix {
 	
 	private double[] matrix;
-	private int size;
+	protected int size;
 	
 	
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/UPGMAMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/UPGMAMatrix.java	(revision 1572)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/UPGMAMatrix.java	(revision 1572)
@@ -0,0 +1,44 @@
+package de.ugoe.cs.autoquest.tasktrees.alignment.matrix;
+
+import de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc.Identifier;
+
+
+public class UPGMAMatrix extends TriangleMatrix {
+
+	public UPGMAMatrix(int size) {
+		super(size);
+	}
+
+	public int size() {
+		return size;
+	}
+
+	public String toString() {
+		String result = "";
+		for (int i = 0; i < size; i++) {
+			result = result + String.format("%8d", i);
+		}
+		result += "\n";
+		
+		for (int i = 0; i < size; i++) {
+			for(int j = 0; j< size; j++) {
+				if(i<j) {
+					if(Double.isInfinite(this.get(i,j))) {
+						result = result + " -------";
+					}
+					else {
+						result = result + String.format("%+8.2f",this.get(i,j));
+					}
+				}
+				else {
+					result = result + ("        ");
+				}
+			}
+			result = result + "   " + i + "\n";
+		}
+		return result;
+	}
+
+	
+
+}
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/FitchMargoliashMatrix.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/substitution/FitchMargoliashMatrix.java	(revision 1571)
+++ 	(revision )
@@ -1,12 +1,0 @@
-package de.ugoe.cs.autoquest.tasktrees.alignment.substitution;
-
-public class FitchMargoliashMatrix extends TriangleMatrix {
-
-	public FitchMargoliashMatrix(int size) {
-		super(size);
-	}
-	
-	
-	
-
-}